Hyper-V

The Hyper-V role enables you to create a virtualized server computing environment using a technology that is part of Windows Server 2008. This type of environment is useful because you can create and manage virtual machines, which allows you to run multiple operating systems on one physical computer and isolate the operating systems from each other. As a result, you can use a virtualized computing environment to improve the efficiency of your computing resources by utilizing more of your hardware resources.

For more information about Hyper-V, see the Windows Server 2008 Technical Library (http://go.microsoft.com/fwlink/?LinkId=93752).

  • Overview of Hyper-V

  • Checklist: Configure Virtual Machines for Server Consolidation

  • Checklist: Configure Virtual Machines for High Availability

  • Checklist: Configure Virtual Machines for Development and Test

  • Hyper-V Installation Prerequisites

  • Configure Hyper-V

  • Create Virtual Machines

  • Create Virtual Hard Disks

  • Configuring Virtual Machines

  • Install a Guest Operating System

  • Connect to a Virtual Machine

  • Manage Virtual Networks

  • About Virtual Machine Snapshots

  • Troubleshooting Hyper-V

  • Resources for Hyper-V

  • User Interface: Hyper-V Manager


Overview of Hyper-V

Hyper-V provides software infrastructure and basic management tools that you can use to create and manage a virtualized server computing environment. This virtualized environment can be used to address a variety of business goals aimed at improving efficiency and reducing costs. For example, a virtualized server environment can help you:

  • Reduce the costs of operating and maintaining physical servers by increasing your hardware utilization. You can reduce the amount of hardware needed to run your server workloads.

  • Increase development and test efficiency by reducing the amount of time it takes to set up hardware and software and reproduce test environments.

  • Improve server availability without using as many physical computers as you would need in a failover configuration that uses only physical computers.

For more information about Hyper-V, see the Windows Server 2008 Technical Library (http://go.microsoft.com/fwlink/?LinkId=93752). For information about the new features in the Windows Server 2008 R2 Hyper-V technology, see http://go.microsoft.com/fwlink/?LinkId=142885.

Additional references

  • Hyper-V Installation Prerequisites

  • Create Virtual Machines

  • Create Virtual Hard Disks

  • Configuring Virtual Machines

  • Install a Guest Operating System

  • Resources for Hyper-V


Checklist: Configure Virtual Machines for Server Consolidation

You can improve the efficiency of your server hardware and reduce the costs of running and maintaining that hardware by consolidating multiple server workloads onto fewer physical systems. The following table identifies the basic tasks required to use Hyper-V to consolidate server workloads.

Task Description

Identify the workloads that are the best candidates for virtualization.

You can use the Microsoft Assessment and Planning Solution Accelerator, which helps gather performance data and generates reports that identify the best candidates for server virtualization. For more information about the tool, see Microsoft Assessment and Planning Toolkit (http://go.microsoft.com/fwlink/?LinkID=111301).

Assess your hardware requirements based on the type and number of servers that you want to consolidate.

You need to assess the processing, storage, and networking requirements of all the workloads that will run on one physical server to determine the hardware requirements of the physical server. For more information about hardware requirements and maximum configurations for Hyper-V, see http://go.microsoft.com/fwlink/?LinkID=129920.

Determine which edition of Windows fits your consolidation plans.

Licensing for Windows Server 2008 includes usage rights for virtualized environments. The number of virtualized instances you can run according to terms of the licensing agreement varies by edition. For more information, see the licensing information at the Microsoft Web site (http://go.microsoft.com/fwlink/?LinkID=111302).

Identify the management tool that suits the needs of your organization.
  • Use Hyper-V Manager, the management snap-in provided with the role. You can use Hyper-V Manager to connect to one physical computer at a time. For information about using Hyper-V Manager for configuration tasks, see the various topics in this Help.

  • Use System Center Virtual Machine Manager to manage larger-scale consolidation, such as a virtualized data center. You can use Virtual Machine Manager to manage multiple physical computers at the same time. For more information, see http://go.microsoft.com/fwlink/?LinkID=111303.

  • Create a custom management solution using the Hyper-V SDK. For information about the Hyper-V WMI provider, see the MSDN site (http://go.microsoft.com/fwlink/?LinkID=108564).

Install the Hyper-V role on the physical servers that will run the role.

For instructions about installing Hyper-V, see the Hyper-V Planning and Deployment Guide (http://go.microsoft.com/fwlink/?LinkID=108560).

Create the virtual machines or migrate them from physical servers.

For instructions about creating virtual machines, see Create Virtual Machines.

For general information about using System Center Virtual Machine Manager to migrate physical servers, see http://go.microsoft.com/fwlink/?LinkID=111303.

Test the workloads to ensure that they perform as expected.

Refer to performance data and any other criteria that you gathered when you assessed the physical servers to identify the candidates for virtualization. Gather similar data for the virtualized workloads and compare it to the original data to determine whether performance is acceptable.

Additional considerations

  • By default, membership in the local Administrators group, or equivalent, is the minimum required to complete this procedure. However, an administrator can use Authorization Manager to modify the authorization policy so that a user or group of users can complete this procedure. For more information, see Using Authorization Manager for Hyper-V Security (http://go.microsoft.com/fwlink/?LinkId=142886).

Additional references

  • For more information about Hyper-V, see the Windows Server 2008 Technical Library (http://go.microsoft.com/fwlink/?LinkId=93752).


Checklist: Configure Virtual Machines for High Availability

This checklist shows the tasks that are required to configure virtual machines for high availability. For information about the tools you use to configure high availability, see the Failover Clusters Help. You can view local Help content by typing the following command at a command prompt: hh cluadmin.chm. Or, you can see Failover Clusters Help in the Windows Server 2008 Technical Library (http://go.microsoft.com/fwlink/?LinkID=143560).

Note

Live migration is a new Hyper-V feature in Windows Server 2008 R2 that makes it possible to move a highly available virtual machine from one node to another node while it is running, without downtime. For more information about live migration, see http://go.microsoft.com/fwlink/?LinkID=139667 and http://go.microsoft.com/fwlink/?LinkId=139664.

Task References

Review concepts related to Hyper-V and virtual machines in the context of a cluster.

If you want to use Cluster Shared Volumes for your virtual machines, review concepts related to Cluster Shared Volumes.

See “Understanding Hyper-V and Virtual Machines in the Context of a Cluster” in Failover Clusters Help.

See “Understanding Cluster Shared Volumes in a Failover Cluster” in Failover Clusters Help.

Install Failover Clustering and the Hyper-V role on each physical server. You can use Server Manager to install both of these technologies.

For instructions about installing Failover Clustering, see "Install Failover Clustering" in Failover Clusters Help.

For instructions about installing Hyper-V, see the Hyper-V Planning and Deployment Guide (http://go.microsoft.com/fwlink/?LinkID=108560).

Connect the networks and storage that the cluster will use.

In Hyper-V Manager, create virtual networks that will be available for virtual machines to use.

Important

Use the same names for the virtual networks when you create them on the different nodes. When a virtual machine fails over from one node to another, the name of the virtual network that the virtual machine is configured to use must be the same.

See “Prepare Hardware Before Validating a Failover Cluster” in Failover Clusters Help.

Manage Virtual Networks

Run the Validate a Configuration Wizard on all the servers that you want to cluster to confirm that the hardware and hardware settings of the servers, network, and storage are compatible with failover clustering. If necessary, adjust hardware or hardware settings and rerun the wizard until all tests pass (required for support).

Important

Validation does not check that the virtualization features of the processors on each server are compatible.

See “Validate a new or existing failover cluster” in Failover Clusters Help.

Use the Create Cluster Wizard to create the failover cluster.

See "Checklist: Create a Failover Cluster" in Failover Clusters Help.

If the clustered servers are connected to a network that is not to be used for network communication in the cluster (for example, a network intended only for iSCSI or only for backup), then configure that network so that it does not allow cluster communication.

See “Modify Network Settings for a Failover Cluster” in Failover Clusters Help.

If you want to use Cluster Shared Volumes and you have not already enabled this feature, enable Cluster Shared Volumes.

See “Enable Cluster Shared Volumes in a Failover Cluster” in Failover Clusters Help.

Use the New Virtual Machine Wizard to create the virtual machines.

Note

Make sure that you create the virtual machine in a new folder and choose a storage location that will be accessible to all the servers in the cluster.

For general instructions, see Create Virtual Machines. For more information about configuring highly available virtual machines, see Configure a Virtual Machine for High Availability. For step-by-step instructions, see Hyper-V Step-by-Step Guide: Hyper-V and Failover Clustering (http://go.microsoft.com/fwlink/?LinkID=129063).

Use the High Availability Wizard to make each virtual machine highly available.

See "Configure a Service or Application for High Availability" in Failover Clusters Help.

Reconfigure the automatic start action for the virtual machine so that it does nothing when the physical computer starts.

Configure virtual machines (http://go.microsoft.com/fwlink/?LinkId=137807)

Test the failover of the clustered virtual machine.

See “Test the Failover of a Clustered Virtual Machine” in Failover Clusters Help.


Checklist: Configure Virtual Machines for Development and Test

Virtual machines can help you recreate computing environments faster and more easily than by using only physical computers. The following table identifies the basic tasks required to configure a development and test environment.

Task | Reference
Determine the networking requirements, including network isolation, of your test environment. Create virtual networks to support these requirements. | For information about planning virtual networks, see Configuring Virtual Networks (http://go.microsoft.com/fwlink/?LinkID=131362). For instructions about creating or modifying a virtual network, see Manage Virtual Networks.
Create virtual machines to recreate the computing environment you want to test. | Create Virtual Machines
Install the appropriate guest operating system on each virtual machine. | Install a Guest Operating System
As necessary, log on to the virtual machine to interact with the guest operating system. | Connect to a Virtual Machine
Take snapshots of the virtual machines before and after making changes that you want to verify or might need to revert. | For instructions about using snapshots, see http://go.microsoft.com/fwlink/?LinkID=108561. For information about planning for and managing snapshots, see About Virtual Machine Snapshots.

Additional considerations

  • By default, membership in the local Administrators group, or equivalent, is the minimum required to complete this procedure. However, an administrator can use Authorization Manager to modify the authorization policy so that a user or group of users can complete this procedure. For more information, see Using Authorization Manager for Hyper-V Security (http://go.microsoft.com/fwlink/?LinkId=142886).

  • You can use virtual machine snapshots to capture the state of a virtual machine while it is running. You can take multiple snapshots of a virtual machine and then revert the virtual machine to any of the previous states by applying a snapshot to the virtual machine. This can make it easier to diagnose the cause of errors by reducing the number of times you need to repeat a task or sequence. Use Hyper-V Manager or Virtual Machine Connection to take snapshots.

Additional references

  • For more information about Hyper-V, see the Windows Server 2008 Technical Library (http://go.microsoft.com/fwlink/?LinkId=93752).


Hyper-V Installation Prerequisites

Hyper-V requires specific hardware. You can identify systems that support the x64 architecture and Hyper-V by searching the Windows Server catalog for Hyper-V as an additional qualification. The Windows Server catalog is available at the Microsoft Web site (http://go.microsoft.com/fwlink/?LinkId=111228).

To install and use the Hyper-V role, you need the following:

  • An x64-based processor. Hyper-V is available in x64-based versions of Windows Server 2008—specifically, the x64-based versions of Windows Server 2008 Standard, Windows Server 2008 Enterprise, and Windows Server 2008 Datacenter.

  • Hardware-assisted virtualization. This is available in processors that include a virtualization option—specifically, Intel Virtualization Technology (Intel VT) or AMD Virtualization (AMD-V).

  • Hardware-enforced Data Execution Prevention (DEP) must be available and be enabled. Specifically, you must enable the Intel XD bit (execute disable bit) or AMD NX bit (no execute bit).

Additional considerations

  • The settings for hardware-assisted virtualization and hardware-enforced DEP are available in the BIOS. However, the names of the settings may differ from the names identified above. For more information about whether a specific processor model supports Hyper-V, check with the manufacturer of the computer.

  • If you modify the settings for hardware-assisted virtualization or hardware-enforced DEP, you may need to turn off the power to the computer and then turn it back on. Restarting the computer may not apply the changes to the settings.

Additional references

  • For more information about Hyper-V, see the Windows Server 2008 Technical Library (http://go.microsoft.com/fwlink/?LinkId=93752).

  • Create Virtual Machines

  • Create Virtual Hard Disks

  • Configuring Virtual Machines

  • Install a Guest Operating System

  • Resources for Hyper-V


Configure Hyper-V

You can configure the server running Hyper-V by modifying Hyper-V settings. You can use these settings to specify where certain files are stored by default and control interactions such as keyboard combinations and logon credentials.

There are two categories of Hyper-V settings:

  • Server settings, which specify the default location of virtual hard disks and virtual machines.

  • User settings, which enable you to customize interactions with Virtual Machine Connection, and display messages and wizard pages if you hid them previously. Settings for Virtual Machine Connection include the mouse release key and Windows key combinations.

To configure Hyper-V settings

  1. Open Hyper-V Manager. Click Start, point to Administrative Tools, and then click Hyper-V Manager.

  2. In the Actions pane, click Hyper-V Settings.

  3. In the navigation pane, click the setting that you want to configure.

  4. Click OK to save the changes and close Hyper-V Settings, or click Apply to save the changes and configure other settings.

Additional considerations

  • By default, membership in the local Administrators group, or equivalent, is the minimum required to complete this procedure. However, an administrator can use Authorization Manager to modify the authorization policy so that a user or group of users can complete this procedure. For more information, see Using Authorization Manager for Hyper-V Security (http://go.microsoft.com/fwlink/?LinkId=142886).

Additional references

  • Create Virtual Machines

  • Connect to a Virtual Machine


Create Virtual Machines

The New Virtual Machine Wizard provides you with a simple and flexible way to create a virtual machine. The New Virtual Machine Wizard is available from Hyper-V Manager.

When you use the wizard, you have two basic options for creating a virtual machine:

  • You can use default settings to create a virtual machine without proceeding through all the configuration pages of the wizard. This type of virtual machine is configured as follows:

    Name

    New Virtual Machine

    Location

    The default location configured for the server running Hyper-V

    Memory

    512 MB

    Network connection

    Not connected

    Virtual hard disk

    Dynamically expanding hard disk with a storage capacity of 127 gigabytes

    Installation options

    No media is specified

    SCSI controller

    No disks connected to this device. Integration services are required in the guest operating system in order to use this device. Some newer versions of Windows include integration services. For more information, see Install a Guest Operating System.

  • You can use settings that you specify on the configuration pages to create a virtual machine that is customized for your needs.

The following procedures describe both methods.

Important

If you plan to make a virtual machine highly available, review Configure a Virtual Machine for High Availability before you create the virtual machine.

To create a default virtual machine

  1. Open Hyper-V Manager. Click Start, point to Administrative Tools, and then click Hyper-V Manager.

  2. From the Action pane, click New, and then click Virtual Machine.

  3. On the Before You Begin page, click Finish. Or, if the Specify Name and Location page is the first page that appears, click Finish on that page.
To create a customized virtual machine

  1. Open Hyper-V Manager. Click Start, point to Administrative Tools, and then click Hyper-V Manager.

  2. From the Action pane, click New, and then click Virtual Machine.

  3. Proceed through the pages of the wizard to specify the custom settings that you want to make. You can click Next to move through each page of the wizard, or you can click the name of a page in the left pane to move directly to that page.

  4. After you have finished configuring the virtual machine, click Finish.

Additional considerations

  • By default, membership in the local Administrators group, or equivalent, is the minimum required to complete this procedure. However, an administrator can use Authorization Manager to modify the authorization policy so that a user or group of users can complete this procedure. For more information, see Using Authorization Manager for Hyper-V Security (http://go.microsoft.com/fwlink/?LinkId=142886).

  • You can customize the settings on as many or as few pages of the New Virtual Machine Wizard as you want, and then click Finish to complete the process. Default values are used for any pages that you did not customize before completing the wizard.

  • Regardless of which method that you use to create a virtual machine, you can change the configuration later by modifying the virtual machine settings. For more information, see Configuring Virtual Machines.

  • Some configurations cannot be made by using the New Virtual Machine Wizard because they are considered to be advanced configurations. Examples include attaching physical disks to a virtual machine and modifying processor settings. You can edit the virtual machine settings to perform advanced configuration. For more information, see Configuring Virtual Machines.

Additional references

  • Install a Guest Operating System

  • New Virtual Machine Wizard

  • New Virtual Hard Disk Wizard


Create Virtual Hard Disks

The New Virtual Hard Disk Wizard provides you with a simple way to create a virtual hard disk. This wizard creates the following types of disks:

  • Fixed virtual hard disk

  • Dynamically expanding virtual hard disk

  • Differencing virtual hard disk

Many of the options you can use to customize the virtual hard disk differ depending on the type of virtual hard disk you create. In all cases, the virtual hard disk requires a name and a storage location.

Important

Do not create the virtual hard disk in a folder that is marked for encryption. Virtual hard disks are stored as .vhd files. Hyper-V does not support the use of storage media if Encrypting File System (EFS) has been used to encrypt the .vhd file. However, you can use files stored on a volume that uses Windows BitLocker Drive Encryption. To download the white paper Windows Server 2008 Hyper-V and BitLocker Drive Encryption see http://go.microsoft.com/fwlink/?LinkID=123534.

To create a virtual hard disk

  1. Open Hyper-V Manager. Click Start, point to Administrative Tools, and then click Hyper-V Manager.

  2. In the Action pane, click New, and then click Hard Disk.

  3. Proceed through the pages of the wizard to customize the virtual hard disk. You can click Next to move through each page of the wizard, or you can click the name of a page in the left pane to move directly to that page.

  4. After you have finished configuring the virtual hard disk, click Finish.

Additional considerations

  • By default, membership in the local Administrators group, or equivalent, is the minimum required to complete this procedure. However, an administrator can use Authorization Manager to modify the authorization policy so that a user or group of users can complete this procedure. For more information, see Using Authorization Manager for Hyper-V Security (http://go.microsoft.com/fwlink/?LinkId=142886).

  • Virtual hard disks are stored as .vhd files, which makes them portable but also poses a potential security risk. We recommend that you mitigate this risk by taking precautions such as storing the .vhd files in a secure location.

  • The virtual hard disk is created when you click Finish to complete the wizard. Depending on the options you choose for the virtual hard disk, the process can take a considerable amount of time.

  • Virtual hard disks cannot be stored in a folder that uses NTFS compression.

  • You can make certain changes to a virtual hard disk after you create it. For example, you can convert it from one type of virtual hard disk to another. You can use the Edit Virtual Hard Disk Wizard to make the changes.

Additional references

  • Install a Guest Operating System

  • New Virtual Hard Disk Wizard


Configuring Virtual Machines

To use Hyper-V to run server workloads in a virtualized environment, you need to create the virtual machines to run the different guest operating systems and applications. You use the New Virtual Machine Wizard to create the virtual machines. The wizard helps you create a virtual machine with a configuration that you choose for the virtual machine name, memory, networking, and storage. The New Virtual Machine Wizard is available from Hyper-V Manager.

After you create a virtual machine, you can customize it by configuring the virtual machine settings. For example, you can:

  • Add or remove virtual hardware, such as a storage controller or a network adapter.

  • Add or remove virtual hard disks.

  • Modify the startup order of devices in the basic input/output system (BIOS).

You can change these settings and many others from Hyper-V Manager.

To configure a virtual machine

  1. Open Hyper-V Manager. Click Start, point to Administrative Tools, and then click Hyper-V Manager.

  2. In the results pane, under Virtual Machines, select the virtual machine that you want to configure.

  3. In the Action pane, under the virtual machine name, click Settings.

  4. In the navigation pane (left pane), click the item you want to configure.

  5. Do one of the following:

    • To add another instance of an item, such as a SCSI controller, select the item and then click Add. Some items may require additional configuration after you add them, such as network adapters.

    • To modify an item, make your changes to the configuration and then click OK.

    • To remove an item, select it if necessary, and then click Remove.

  6. To make more changes, click the next item that you want to configure and repeat step 5. When you are finished with the configuration, click OK.

Additional considerations

  • By default, membership in the local Administrators group, or equivalent, is the minimum required to complete this procedure. However, an administrator can use Authorization Manager to modify the authorization policy so that a user or group of users can complete this procedure. For more information, see Using Authorization Manager for Hyper-V Security (http://go.microsoft.com/fwlink/?LinkId=142886).

Additional references

  • Configure Memory and Processors

  • Configure Networking

  • Configure Disks and Storage

  • Configure a Virtual Machine for High Availability

  • New Virtual Machine Wizard

  • New Virtual Hard Disk Wizard

  • Windows Server 2008 Technical Library (http://go.microsoft.com/fwlink/?LinkId=93752).


Configure Memory and Processors

When you create a virtual machine, you configure the memory and processor to provide the appropriate computing resources for the workload you plan to run on the virtual machine. This workload consists of the guest operating system and all applications and services that will run at the same time on the virtual machine.

If you need to adjust the computing resources of a virtual machine, you can reconfigure the resources to meet the changing needs. You can also specify resource controls to automate how resources are allocated to virtual machines.

Configure memory or processors for a virtual machine

A virtual machine needs enough memory allocated to it to run the workload. However, each virtual machine consumes memory only when it is running or paused. For more information about determining memory allocation, see “Performance Tuning for Virtualization Servers” in the Performance Tuning Guidelines for Windows Server 2008 (http://go.microsoft.com/fwlink/?LinkID=135682).

The number of virtual processors you should configure depends on the guest operating system. For more information about determining the appropriate memory and processors for the guest operating system that will run on the virtual machine, see About Virtual Machines and Guest Operating Systems (http://go.microsoft.com/fwlink/?LinkID=128037).

Hyper-V provides processor compatibility settings to make it easier to use an older operating system and to make it easier to perform a live migration of a virtual machine to another physical computer with a different processor version. The following considerations apply to the migration scenario:

  • The Migrate to a physical computer with a different processor version setting ensures that the virtual machine uses only the features of the processor that are available on all versions of a virtualization-capable processor by the same processor manufacturer. It does not provide compatibility between different processor manufacturers.

  • The setting is useful for high availability and backup and recovery scenarios because it makes it easier to move a highly available virtual machine to another node in a cluster or restore the virtual machine to different hardware.

Note

If the physical computer has multiple processors and uses non-uniform memory architecture (NUMA), we recommend that you do not assign more processors or memory to a virtual machine than are available on a single NUMA node. For example, do not assign 4 processors to a virtual machine if each NUMA node has only two processors. For more information about the processor architecture of the physical computer, see the documentation that came with the computer.

To configure memory or processors for a virtual machine

  1. Open Hyper-V Manager. Click Start, point to Administrative Tools, and then click Hyper-V Manager.

  2. In the results pane, under Virtual Machines, select the virtual machine that you want to configure.

  3. In the Action pane, under the virtual machine name, click Settings. Then, in the navigation pane, click the appropriate hardware setting as described in the following steps.

  4. To configure the memory, click Memory. On the Memory page, specify the new amount of memory.

  5. To configure the processor, click Processor. If multiple processors are supported by the guest operating system, specify the number of processors to assign to the virtual machine. Then click OK.

Configure resource allocation for a virtual machine

Resource controls provide you with several ways to control the way that Hyper-V allocates resources to virtual machines. The following is a brief description of each control. For more information about the controls, see “Weights and Reserves” in the Performance Tuning Guidelines for Windows Server 2008 (http://go.microsoft.com/fwlink/?LinkID=135682).

  • Virtual machine reserve. Of the processor resources available to a virtual machine, specifies the percentage that is reserved for the virtual machine. This setting guarantees that the percentage you specify will be available to the virtual machine. This setting can also affect how many virtual machines you can run at one time.

  • Virtual machine limit. Of the processor resources available to a virtual machine, specifies the maximum percentage that can be used by the virtual machine. This setting applies regardless of whether other virtual machines are running.

  • Relative weight. Specifies how Hyper-V allocates resources to this virtual machine when more than one virtual machine is running and the virtual machines compete for resources.

To configure resource allocation for a virtual machine

  1. Open Hyper-V Manager. Click Start, point to Administrative Tools, and then click Hyper-V Manager.

  2. In the results pane, under Virtual Machines, select the virtual machine that you want to configure.

  3. In the Action pane, under the virtual machine name, click Settings.

  4. In the navigation pane, click Processor.

  5. Under Resource control, specify the amount for each control you want to use. Then click OK.

Additional considerations

  • By default, membership in the local Administrators group, or equivalent, is the minimum required to complete this procedure. However, an administrator can use Authorization Manager to modify the authorization policy so that a user or group of users can complete this procedure. For more information, see Using Authorization Manager for Hyper-V Security (http://go.microsoft.com/fwlink/?LinkId=142886).

  • The virtual machine must be turned off before you can modify the memory or processor settings.

Additional references

  • Install a Guest Operating System

  • Troubleshooting Hyper-V


Configure Networking

Providing a virtual machine with networking capabilities requires the same two basic components that a physical computer requires: a network adapter and an available network. When you create a virtual machine, it is automatically configured with one network adapter. If one or more virtual networks are available on the server running Hyper-V, you can connect the network adapter to one of those networks at that time.

Hyper-V provides two types of virtual network adapters—a network adapter and a legacy network adapter:

  • A network adapter requires a virtual machine driver in order to work, but offers better performance. This driver is included with some newer versions of Windows. On all other supported operating systems, install integration services in the guest operating system to install the virtual machine driver. For instructions, see Install a Guest Operating System. For more information about which operating systems are supported and which of those require you to install integration services, see About Virtual Machines and Guest Operating Systems (http://go.microsoft.com/fwlink/?LinkID=128037).

  • A legacy network adapter works without installing a virtual machine driver. The legacy network adapter emulates a physical network adapter, multiport DEC 21140 10/100TX 100 MB. A legacy network adapter also supports network-based installations because it includes the ability to boot to the Pre-Execution Environment (PXE boot). However, the legacy network adapter is not supported in the 64-bit edition of Windows Server 2003.

Note

The legacy network adapter requires processing in the management operating system that is not required by the network adapter. We recommend that you use the legacy network adapter only to perform a network-based installation or when the guest operating system does not support the network adapter.

After you create a virtual machine, you can configure networking for virtual machines by adding, removing, and modifying their network adapters as necessary. Each network adapter can be connected to one of the virtual networks available on the server running Hyper-V.

Note

You can use Virtual Network Manager to add, remove, and modify virtual networks. You also can use Virtual Network Manager to specify a range of media access control (MAC) addresses to assign to virtual machines.

To add a network adapter

  1. Open Hyper-V Manager. Click Start, point to Administrative Tools, and then click Hyper-V Manager.

  2. In the results pane, under Virtual Machines, select the virtual machine that you want to configure.

  3. In the Action pane, under the virtual machine name, click Settings.

  4. In the navigation pane, click Add Hardware.

  5. On the Add Hardware page, choose a network adapter or a legacy network adapter. For more information about each type of adapter, see "Additional Considerations" below.

  6. Click Add. The Network Adapter or Legacy Network Adapter page appears.

  7. Under Network, select the virtual network you want to connect to.

  8. If you want to configure a static MAC address or virtual LAN identifier, specify the numbers you want to use.

  9. Click OK.
To modify or remove a network adapter

  1. Open Hyper-V Manager. Click Start, point to Administrative Tools, and then click Hyper-V Manager.

  2. In the results pane, under Virtual Machines, select the virtual machine that you want to configure.

  3. In the Action pane, under the virtual machine name, click Settings.

  4. In the navigation pane, click the name of the network adapter.

  5. On the Network Adapter or Legacy Network Adapter page, do one of the following:

    • To modify the configuration, make your changes and then click Apply.

    • To remove the network adapter, click Remove.

  6. Click OK.

Additional considerations

  • By default, membership in the local Administrators group, or equivalent, is the minimum required to complete this procedure. However, an administrator can use Authorization Manager to modify the authorization policy so that a user or group of users can complete this procedure. For more information, see Using Authorization Manager for Hyper-V Security (http://go.microsoft.com/fwlink/?LinkId=142886).

  • You can use Virtual Network Manager to constrain the range of dynamic MAC addresses. When more than one physical computer running Hyper-V uses the same subnet, this helps you avoid potential conflicts that would result if the same MAC address is assigned to more than one virtual machine on the subnet.

Additional references

  • Manage Virtual Networks

  • For more information about Hyper-V, see Configuring Virtual Networks (http://go.microsoft.com/fwlink/?LinkID=131362).


Configure Disks and Storage

A virtual machine can use three types of storage media:

  • Hard disks, both virtual hard disks and physical disks

  • CDs and DVDs, both physical discs and image files (also known as .iso files)

  • Virtual floppy disks

To make various types of media and storage available to a virtual machine, you must configure the drive for the virtual machine by adding or removing it, or by changing the media.

You can add or remove virtual hard disks and physical disks attached directly to a virtual machine even when the virtual machine is running. The disks must be attached to a virtual machine SCSI controller and integration services must be installed in the guest operating system. As a best practice, we recommend taking a disk offline in the guest operating system before you remove the disk to avoid potential data loss.

Note

At a minimum, a virtual machine requires at least one disk to provide a location to install the guest operating system. You can add or remove additional drives as needed. When you create a virtual machine, a DVD drive is added automatically.

Configure hard disks, CDs, and DVDs

To configure hard disks, CDs, and DVDs for a virtual machine, you modify the settings of the virtual machine.

Important

The disk that serves as the system disk must be attached to one of the IDE controllers. If you attach the system disk to a SCSI controller, the virtual machine will not start.

To add a hard disk to a virtual machine

  1. Open Hyper-V Manager. Click Start, point to Administrative Tools, and then click Hyper-V Manager.

  2. In the results pane, under Virtual Machines, select the virtual machine that you want to configure.

  3. In the Action pane, under the virtual machine name, click Settings.

  4. In the navigation pane (left pane), click the controller that you want to attach the disk to.

  5. Click Add.

  6. On the Hard Drive page, select the location on the controller to attach the disk.

  7. Under Media, do one of the following:

    • Specify the location of the virtual hard disk (.vhd) file.

    • Specify a physical hard disk.

  8. Click OK.
To modify or remove a hard drive or DVD drive

  1. Open Hyper-V Manager. Click Start, point to Administrative Tools, and then click Hyper-V Manager.

  2. In the results pane, under Virtual Machines, select the virtual machine that you want to configure.

  3. In the Action pane, under the virtual machine name, click Settings.

  4. In the navigation pane (left pane), click the hard drive or the DVD drive.

  5. On the Hard Drive or DVD Drive page, do one of the following:

    • To attach the drive to different media, under Media, select the appropriate media.

    • To remove the drive, click Remove.

  6. Click OK.

Configure the diskette drive

To make a virtual floppy disk available to a virtual machine, you must attach the virtual floppy disk (.vfd) file to the diskette drive. The diskette drive is always available and cannot be removed.

To configure the diskette drive

  1. Open Hyper-V Manager. Click Start, point to Administrative Tools, and then click Hyper-V Manager.

  2. In the results pane, under Virtual Machines, select the virtual machine that you want to configure.

  3. In the Action pane, under the virtual machine name, click Settings.

  4. In the navigation pane (left pane), click Diskette Drive.

  5. Under Media, click Virtual floppy disk (.vfd) file and then type or browse to the location of the .vfd file.

  6. Click OK.

Additional considerations

  • By default, membership in the local Administrators group, or equivalent, is the minimum required to complete this procedure. However, an administrator can use Authorization Manager to modify the authorization policy so that a user or group of users can complete this procedure. For more information, see Using Authorization Manager for Hyper-V Security (http://go.microsoft.com/fwlink/?LinkId=142886).

  • Hyper-V does not support the use of storage media if Encrypting File System has been used to encrypt .iso, .vhd, and .vfd files. However, you can use files stored on a volume that uses Windows BitLocker Drive Encryption.

  • Do not attach a virtual hard disk to a virtual machine if the .vhd file is stored in a compressed folder. The virtual machines will not be able to access the virtual hard disk.

  • Do not store .vhd files on shared folders.

  • Only one virtual machine can access a physical CD or DVD drive at a time.

  • To allow a virtual machine to access an .iso file on a shared folder in a domain environment, you must configure the server running Hyper-V for constrained delegation. Configure the computer account of the server running Hyper-V to present delegated credentials for the Common Internet File System (CIFS) service type.

  • A physical disk must be offline before you can add it to a virtual machine. You can use Disk Manager to take a physical disk offline.

Additional references

  • Install a Guest Operating System

  • New Virtual Hard Disk Wizard

  • Edit Virtual Hard Disk Wizard


Configure a Virtual Machine for High Availability

A highly available virtual machine requires that you perform some specific configuration and tasks. Some configuration and tasks must be done before you make the virtual machine highly available, while others must be done afterward. Before you try to make a virtual machine highly available, review the following information to make sure that the virtual machine is configured appropriately.

Before you make the virtual machine highly available

Before you make the virtual machine highly available, you need to review, and in some cases, modify the networking, security, and storage in your environment.

  • Networking. All nodes in the same cluster must use the same name for the virtual network that provides external networking for the virtual machines. For example, if you created a virtual network through the Add Roles Wizard when you installed the role, a name is assigned to the virtual network based on the network adapter. This name will be different on each physical computer. You must delete the virtual network and then recreate it, using the same name on each physical computer in the cluster. Also note that if a physical network adapter uses static settings, such as a static IP address, and IPv6 is not disabled, the static settings will be deleted when you connect a virtual network to the physical adapter. In that case, you must reconfigure the static settings.

  • Processor. If the nodes in your cluster use different processor versions, make sure that you configure the virtual machine for processor compatibility. This helps ensure that you can failover or migrate a virtual machine without encountering problems due to different virtualization features on different versions of the same manufacturer’s processor. However, this does not provide compatibility between different processor manufacturers.

  • Security. To avoid potential problems you might encounter trying to administer highly available virtual machines, all nodes in the cluster must use the same authorization policy. There are two ways you can accomplish this:

    • Use a local, XML-based authorization store on each node. The policy must be configured the same on each store in the cluster.

    • Use an authorization store located in Active Directory Domain Services (AD DS).

  • Storage. You must use shared storage that is supported by both the Failover Clustering feature and Hyper-V. When you create the virtual machine, choose the option to store the virtual machine in a new folder and specify the location of the shared storage. For more information about cluster storage, see Failover Clusters (http://go.microsoft.com/fwlink/?LinkID=143559).

Note

The virtual machine must be turned off so that you can make it highly available. To make a virtual machine highly available, you run the High Availability wizard from the Failover Cluster Management snap-in and select Virtual Machine as the service or application to make highly available.

After you make the virtual machine highly available

After you make the virtual machine highly available, do the following:

  • Install the guest operating system and the integration services. For instructions, see Install a Guest Operating System.

  • Configure the virtual machine to take no action through Hyper-V if the physical computer shuts down by modifying the Automatic Stop Action setting to None. Virtual machine state must be managed through the Failover Clustering feature. For more information about the setting, see Virtual Machine Settings.

  • If you use snapshots on a clustered virtual machine, all resources associated with each snapshot must be stored on the same shared storage as the virtual machine.

  • If you change the configuration of a virtual machine, we recommend that you use the Failover Manager snap-in to access the virtual machine settings. When you do this, the cluster is updated automatically with the configuration changes. However, if you make changes to the virtual machine settings from the Hyper-V Manager snap-in, you must update the cluster manually after you make the changes. If the configuration is not refreshed after networking or storage changes are made, a subsequent failover may not succeed or may succeed but result in the virtual machine being configured incorrectly.

Important

Changing the offline action affects the behavior of the virtual machine if a failover occurs. For example, if you choose a shutdown action and a failover occurs, the virtual machine will shut down instead of fail over to another node.

Additional considerations

  • By default, membership in the local Administrators group, or equivalent, is the minimum required to complete this procedure. However, an administrator can use Authorization Manager to modify the authorization policy so that a user or group of users can complete this procedure. For more information, see Using Authorization Manager for Hyper-V Security (http://go.microsoft.com/fwlink/?LinkId=142886).

Additional references

  • Checklist: Configure Virtual Machines for High Availability

  • Configuring Virtual Machines


Install a Guest Operating System

A guest operating system is the operating system that you install and run in a virtual machine. Before you can install the guest operating system, if you did not specify the location of the installation media when you created the virtual machine, you will need to perform one of the following steps:

  • Obtain the installation media for the operating system and configure the virtual machine to use the CD/DVD drive to access the installation media. For instructions, see Configure Disks and Storage.

  • If you want to perform a network-based installation, configure the virtual machine to use a legacy network adapter that is connected to an external virtual network. This type of network provides connectivity to a physical network by routing traffic through an external virtual network to a physical network adapter. For more information, see Configure Networking.

After you have configured the virtual machine appropriately, you can install the guest operating system.

To install the guest operating system

  1. Open Hyper-V Manager. Click Start, point to Administrative Tools, and then click Hyper-V Manager.

  2. Connect to the virtual machine. From the Virtual Machines section of the results pane, using one of the following methods:

    • Right-click the name of the virtual machine and click Connect.

    • Select name of the virtual machine. In the Action pane, click Connect.

  3. The Virtual Machine Connection tool opens.

  4. From the Action menu in the Virtual Machine Connection window, click Start.

  5. The virtual machine starts, searches the startup devices, and loads the installation package.

  6. Proceed through the installation.

Note

Depending on the operating system being installed, the mouse pointer may change to a small dot when you move the mouse cursor over the image of the setup window. If this occurs, click anywhere in the virtual machine window. This action "captures" the mouse so that keyboard and mouse input is sent to the virtual machine. To return the input to the physical computer, press CTRL+ALT+LEFT ARROW and then move the mouse pointer outside of the virtual machine window.

Hyper-V includes a software package for supported guest operating systems that improves integration between the physical computer and the virtual machine. This package is referred to as integration services. Newer versions of supported Windows operating systems include the integration services and do not require installation after you install the guest operating system. For more information about which operating systems are supported and which of those require you to install integration services, see the deployment content for Hyper-V at the Windows Server 2008 Technical Library (http://go.microsoft.com/fwlink/?LinkID=128037).

Note

The following instructions assume that you are installing an operating system for which the software package is available and installation is required.

To install integration services

  1. Connect to the virtual machine. From the Virtual Machines section of the results pane, using one of the following methods:

    • Right-click the name of the virtual machine and click Connect.

    • Select the name of the virtual machine. In the Action pane, click Connect.

  2. The Virtual Machine Connection tool opens.

  3. From the Action menu of Virtual Machine Connection, click Insert Integration Services Setup Disk. This action loads the setup disk in the virtual DVD drive.

  4. Depending on the operating system being installed, you may need to start the installation manually. Click anywhere in the guest operating system window and navigate to the CD drive. Use the method that is appropriate for the guest operating system to start the installation package from the CD drive.

  5. After the installation finishes, all integration services are available for use.

Additional considerations

  • By default, membership in the local Administrators group, or equivalent, is the minimum required to complete this procedure. However, an administrator can use Authorization Manager to modify the authorization policy so that a user or group of users can complete this procedure. For more information, see Using Authorization Manager for Hyper-V Security (http://go.microsoft.com/fwlink/?LinkId=142886).

  • The use of Virtual Machine Connection within a Remote Desktop Services session is not supported unless integration services are installed.

  • Integration services for supported Linux operating systems are not included with an installation of Hyper-V. They are distributed through the Microsoft Connect Web site and are identified as Linux Integration Components for Microsoft Hyper-V. For more information, see http://go.microsoft.com/fwlink/?LinkID=102024.

Additional references

  • Configuring Virtual Machines

  • Virtual Machine Connection


Connect to a Virtual Machine

Virtual Machine Connection is a tool that you use to connect to a virtual machine so that you can install or interact with the guest operating system in a virtual machine. Some of the tasks that you can perform by using Virtual Machine Connection include the following:

  • Connect to the video output of a virtual machine

  • Control the state of a virtual machine

  • Take snapshots of a virtual machine

  • Modify the settings of a virtual machine

Before you begin

Virtual Machine Connection is installed automatically when you install the Hyper-V role on a full installation of Windows Server 2008. You also can install it separately on certain versions of Windows. For more information about installing Virtual Machine Connection, see http://go.microsoft.com/fwlink/?LinkId=143558.

By default, Virtual Machine Connection uses the same credentials you used to log on to your current Windows session to also establish a session to a running virtual machine. If you want Virtual Machine Connection to use a different set of credentials, you can configure Hyper-V so that you will be prompted for credentials. For instructions, see Configure Hyper-V.

Connect to a virtual machine

To connect to a virtual machine from Hyper-V Manager

  1. Open Hyper-V Manager. Click Start, point to Administrative Tools, and then click Hyper-V Manager.

  2. In the results pane, under Virtual Machines, right-click the name of the virtual machine and click Connect.

  3. The Virtual Machine Connection tool opens.

Tips for using Virtual Machine Connection

You may find the following tips to be helpful for using Virtual Machine Connection:

  • You can move the mouse pointer seamlessly between the operating system running on the physical computer and the guest operating system when integration services are installed on the guest operating system. Integration services are included with newer versions of supported Windows operating systems. For all other supported operating systems, install integration services in the guest operating system. For instructions about installing integration services, see Install a Guest Operating System. For a list of guest operating systems which integration services are available for, see the Windows Server 2008 Technical Library (http://go.microsoft.com/fwlink/?LinkID=128037).

  • The mouse pointer may appear as a small dot when you connect to a running virtual machine. To send mouse clicks or keyboard input to the virtual machine, click anywhere in the virtual machine window. To return the input to the physical computer, press the mouse release key combination and then move the mouse pointer outside of the virtual machine window. The default release key combination is CTRL+ALT+LEFT arrow, but the key combination can be changed by modifying Hyper-V settings.

  • You cannot press CTRL+ALT+DELETE on the keyboard to send that key combination to a virtual machine. You can use the menu command. From the Action menu, click Ctrl+Alt+Delete. Or, you can press CTRL+ALT+END.

  • You can switch from a window mode to a full-screen mode. From the View menu, click Full Screen Mode. To switch back to window mode, press CTRL+ALT+BREAK.

Additional considerations

  • By default, membership in the local Administrators group, or equivalent, is the minimum required to complete this procedure. However, an administrator can use Authorization Manager to modify the authorization policy so that a user or group of users can complete this procedure. For more information, see Using Authorization Manager for Hyper-V Security (http://go.microsoft.com/fwlink/?LinkId=142886).

  • If an authorized user is connected to a virtual machine through Virtual Machine Connection and another authorized user decides to use the console of the same virtual machine, the session will be taken over by the second user and the first user will lose the session. This can pose a privacy and security risk, because the second user will be able to view the first user's desktop, documents, and applications. A virtual machine session is available to all users who have been granted the Console Read or Console Read/Write operations privilege in the authorization policy. By default, this is granted to any Administrator. To avoid or fix this issue, adjust the privileges to restrict access as appropriate.

Additional references

  • Create Virtual Machines

  • Install a Guest Operating System

  • Troubleshooting Hyper-V


Manage Virtual Networks

You can create many virtual networks on the server running Hyper-V to provide a variety of communications channels. For example, you can create networks to provide the following:

  • Communications between virtual machines only. This type of virtual network is called a private network.

  • Communications between the virtualization server and virtual machines. This type of virtual network is called an internal network.

  • Communications between a virtual machine and a physical network by creating an association to a physical network adapter on the virtualization server. This type of virtual network is called an external network. As a best practice, we recommend that you provide the physical computer with more than one physical network adapter. Use one physical network adapter to provide virtual machines with an external virtual network, including remote access to the virtual machines. Use the other network adapter for all network communications with the management operating system, including remote access to the Hyper-V role. The management operating system runs the Hyper-V role.

Important

Some configuration changes overwrite static settings. For example, if you connect a virtual network to a physical network adapter that uses static settings, such as a static IP address, the new connection will overwrite all IPv6 static settings. If you create an external network without sharing that network connection with the management operating system, and then reconfigure the external network to allow the management operating system to use the connection, that change will overwrite all static settings on the physical network adapter. Network connectivity may be lost until you reapply the static settings to the physical network adapter.

You can use Virtual Network Manager to add, remove, and modify the virtual networks. Virtual Network Manager is available from Hyper-V Manager.

To add a virtual network

  1. Open Hyper-V Manager.

  2. From the Actions menu, click Virtual Network Manager.

  3. Under Create virtual network, select the type of network you want to create.

  4. Click Add. The New Virtual Network page appears.

  5. Type a name for the new network. Review the other properties and modify them if necessary.

    Note

    You can use virtual LAN identification as a way to isolate network traffic. However, this type of configuration must be supported by the physical network adapter. For information about configuring virtual LAN identification, see Configuring Virtual Networks (http://go.microsoft.com/fwlink/?LinkID=131362).

  6. Click OK to save the virtual network and close Virtual Network Manager, or click Apply to save the virtual network and continue using Virtual Network Manager.
To modify a virtual network

  1. Open Hyper-V Manager.

  2. From the Actions menu, click Virtual Network Manager.

  3. Under Virtual Networks, click the name of the network you want to modify.

  4. Under Virtual Network Properties, edit the appropriate properties to modify the virtual network.

  5. Click OK to save the changes and close Virtual Network Manager, or click Apply to save the changes and continue using Virtual Network Manager.
To remove a virtual network

  1. Open Hyper-V Manager.

  2. From the Actions menu, click Virtual Network Manager.

  3. Under Virtual Networks, click the name of the network you want to remove.

  4. Under Virtual Network Properties, click Remove.

  5. Click OK to save the changes and close Virtual Network Manager, or click Apply to save the changes and continue using Virtual Network Manager.

Additional considerations

  • By default, membership in the local Administrators group, or equivalent, is the minimum required to complete this procedure. However, an administrator can use Authorization Manager to modify the authorization policy so that a user or group of users can complete this procedure. For more information, see Using Authorization Manager for Hyper-V Security (http://go.microsoft.com/fwlink/?LinkId=142886).

  • You cannot connect a virtual network to a wireless network adapter. As a result, you cannot provide wireless networking capabilities to virtual machines.

  • Only one virtual network can be attached to a specific physical network adapter at a time; you cannot attach multiple virtual networks to the same physical network adapter.

Additional references

  • Configure Networking


About Virtual Machine Snapshots

Virtual machine snapshots are file-based snapshots of the state, disk data, and configuration of a virtual machine at a specific point in time. You can take multiple snapshots of a virtual machine, even while it is running. You can then revert the virtual machine to any of the previous states by applying a snapshot to the virtual machine.

To take a snapshot, you can use either Hyper-V Manager or Virtual Machine Connection. All of the other tasks you can perform with snapshots, such as applying or deleting a snapshot, or viewing a list of all snapshots for a specific virtual machine, are available through Hyper-V Manager. You also can inspect or edit the .avhd files, as well as determine which snapshot an .avhd file is associated with. For instructions on using and managing virtual machine snapshots, see the Windows 2008 Technical Library (http://go.microsoft.com/fwlink/?LinkID=143557).

Important

Do not edit a virtual hard disk when it is used by a virtual machine that has snapshots.

Considerations about virtual machine snapshots

Snapshots can help you increase efficiency in many settings where you need to recreate different computing environments and reproduce various conditions in those environments. Some examples include software development and test, technical support services, and training curriculum development.

However, the same power and flexibility that makes these snapshots useful and effective in certain settings can cause unintended and potentially serious consequences in other settings. These consequences include the inherent risks of unintended data loss if the snapshots are not managed appropriately. For example, if you edit a virtual hard disk connected to a virtual machine that has snapshots, data loss may occur.

Appropriate settings for using snapshots are development and test activities, including using a virtual machine as a staging server to test updates and hotfixes before deploying them to production servers. We do not recommend using snapshots on virtual machines that provide time-sensitive services such as Active Directory services, or when performance or the availability of storage space is critical.

Additionally, you should consider the following before you start using snapshots:

  • Taking a snapshot reduces the performance of the virtual machine while the snapshot is created. You should not use these snapshots on virtual machines that provide services in a production environment.

  • We do not recommend using snapshots on virtual machines that are configured with fixed virtual hard disks because they reduce the performance benefits that are otherwise gained by using fixed virtual hard disks.

  • Snapshots require adequate storage space. Snapshots are stored as .avhd files in the same location at the virtual hard disk. Taking multiple snapshots can quickly consume a large amount of storage space. When you use Hyper-V Manager to delete a snapshot, the snapshot is removed from the snapshot tree but the .avhd file is not deleted until you turn off the virtual machine.

    Caution

    Do not delete .avhd files directly from the storage location.

  • Virtual machine snapshots are not the same as the snapshots created by Volume Shadow Copy Services (VSS). Virtual machine snapshots can be a useful way to create temporary backups of a virtual machine, but are not a replacement for a permanent backup solution. For more information about backing up virtual machines, see Planning for Backup (http://go.microsoft.com/fwlink/?LinkId=143125).

Additional references

  • Troubleshooting Hyper-V

  • Resources for Hyper-V


Troubleshooting Hyper-V

This topic covers some common issues you may encounter when using Hyper-V. For more in-depth troubleshooting information based on Hyper-V events, see the Hyper-V troubleshooting content in the Windows Server 2008 Technical Library (http://go.microsoft.com/fwlink/?LinkID=108562). To search the Knowledge Base for articles about Hyper-V, see Help and Support at http://go.microsoft.com/fwlink/?LinkId=113139.

What problem are you having?

I installed the Hyper-V role and can create or import a virtual machine, but I can’t start the virtual machine.

Cause: The hypervisor is not running. The following error appears in the System event log: “The virtual machine could not be started because the hypervisor is not running.”

Solution: The physical computer must meet specific hardware requirements to run the hypervisor. For more information, see Hyper-V Installation Prerequisites. If the computer does not meet the requirements, you will not be able to use that computer to run virtual machines. If the computer meets the requirements and the hypervisor is not running, you might need to enable the settings for hardware-assisted virtualization and hardware-enforced Data Execution Prevention (DEP) in the BIOS. If you modify these settings, you must turn off the power to the computer and then turn it back on. Restarting the computer does not apply the changes to the settings.

Cause: The virtual disk that serves as the system disk is attached to a SCSI controller.

Solution: Attach the system disk to an IDE controller. For instructions, see Configure Disks and Storage.

Cause: The virtual machine is configured to use a physical CD or DVD as the installation media, and the physical drive is in use.

Solution: A physical CD or DVD drive can be accessed by only one virtual machine at a time. Disconnect the CD or DVD from the other virtual machine and try again.

I cannot perform a network-based installation of a guest operating system.

Cause: The virtual machine is using a network adapter instead of a legacy network adapter, or the legacy network adapter is not connected to an appropriate external network.

Solution: Ensure that the virtual machine is configured with a legacy network adapter that is connected to an external network which offers installation services. For instructions about configuring network adapters, see Configure Networking.

A virtual machine pauses automatically.

Cause: A virtual machine will be paused automatically when the volume on which snapshots or virtual hard disks are stored runs out of available storage. The state of the virtual machine will be listed as “paused-critical” in Hyper-V Manager.

Solution: Create additional space on the drive by using Hyper-V Manager to apply or delete the snapshots individually. Or, to delete all of the snapshots, export the virtual machine without exporting the virtual machine data and then import the virtual machine.

When I try to create or start a virtual machine, I receive error messages about a “user-mapped section open”, “the specified network resource or device is no longer available”, or the “I/O operation aborted because of either a thread exit or an application request”.

Cause: This can be caused by antivirus software running in the management operating system when the real-time scanning component is configured to monitor the Hyper-V virtual machine files.

Solution: Exclude the virtual machine files from real-time scanning. For information about the specific files, see article 961804 in the Microsoft Knowledge Base (http://go.microsoft.com/fwlink/?LinkId=143978).

Virtual machines have disappeared from the Hyper-V Manager console.

Cause: This can be caused by antivirus software running in the management operating system when the real-time scanning component is configured to monitor the Hyper-V virtual machine files.

Solution: Exclude the virtual machine files from real-time scanning. For information about the specific files, see article 961804 in the Microsoft Knowledge Base (http://go.microsoft.com/fwlink/?LinkId=143978).

When I use Virtual Machine Connection, the mouse pointer appears as a dot or the mouse pointer is stuck in the virtual machine window.

Cause: Integration services are not installed in the guest operating system.

Solution: If the guest operating system is supported, integrations services are available for that operating system. Install the integration services to improve mouse integration. For instructions, see Install a Guest Operating System. If the guest operating system is not supported, you can use a key combination to move the mouse out of the virtual machine window. The default key combination is CTRL+ALT+LEFT ARROW.

When I try to control a virtual machine, I cannot use the mouse. I am using Remote Desktop Connection to connect to a server running Hyper-V.

Cause: When you use Hyper-V Manager to connect to a virtual machine, Virtual Machine Connection provides the connection to the virtual machine. However, use of Virtual Machine Connection within a Remote Desktop Connection session is not supported until integration services are installed. As a result, lack of mouse functionality is expected behavior.

Solution: Avoid using Virtual Machine Connection within a Remote Desktop Connection session until integration services are installed. There are several ways you can accomplish this:

  • Install integration services. For instructions, see Install a Guest Operating System.

  • Establish a Remote Desktop session directly to the virtual machine.

  • Log on to the console of the server running Hyper-V and then use Virtual Machine Connection to connect to the virtual machine.

  • On a supported client computer, install the Hyper-V management tools to install Virtual Machine Connection on the computer and establish a Virtual Machine Connection session to the virtual machine. For more information, see the Windows Server 2008 Technical Library (http://go.microsoft.com/fwlink/?LinkId=143558).

When I open Device Manager in the guest operating system, some devices are listed as unknown devices.

Cause: Device Manager does not recognize devices that are optimized for use in virtual machines and run using Hyper-V until integration services are installed. The unknown devices that are identified in Device Manager differ depending on the guest operating system and may include: VMBus, Microsoft VMBus HID Miniport, Microsoft VMBus Network Adapter, and storvsc miniport.

Note

Some optimized devices are not available for certain guest operating systems. When a device is not supported on a guest operating system, the device will not work. You cannot install the device driver manually to try to make the device work. For a list of the devices that are available on each supported guest operating system, see http://go.microsoft.com/fwlink/?LinkID=128037.

Solution: If the guest operating system is supported, integration services are available for that operating system. After you install the integration services, Device Manager will recognize the devices that are available for that guest operating system. For instructions, see Install a Guest Operating System.

I want to monitor the performance of a virtual machine, but the processor information displayed in Task Manager does not show the processor resources being used by the virtual machine.

Cause: Task Manager does not display CPU information for virtual machines.

Solution: To view CPU usage information for virtual machines running on a server running Hyper-V, use Performance and Reliability Monitor to view the data from Hyper-V performance counters. To open Performance and Reliability Monitor, click Start, click Run, and then type perfmon.

The following performance counters provide information when viewed on the management operating system (the operating system that runs the Hyper-V role):

  • Hyper-V Hypervisor Logical Processor % Guest Run time: Identifies how much of the physical processor is being used to run the virtual machines. This counter does not identify the individual virtual machines or the amount consumed by each virtual machine.

  • Hyper-V Hypervisor Virtual Processor %Guest Run time: Identifies how much of the virtual processor is being consumed by a virtual machine.

Note

There is no direct mapping of virtual processor consumption to logical processor consumption because the virtual processors can be scheduled on any of the logical processors.


Resources for Hyper-V

Help for Hyper-V Manager is intended to provide you with basic information about using the Hyper-V role to create and configure virtual machines. More information about Hyper-V is available at the following locations on the Microsoft Web site:

  • For technical information, see the Windows Server 2008 Technical Library (http://go.microsoft.com/fwlink/?LinkId=93752).

  • For more in-depth troubleshooting information, see http://go.microsoft.com/fwlink/?LinkID=108562.

  • For information about the Hyper-V WMI provider, see http://go.microsoft.com/fwlink/?LinkID=108564.

  • To search the Knowledge Base for articles about Hyper-V, see Microsoft Help and Support (http://go.microsoft.com/fwlink/?LinkId=113139).

  • For general information about the various virtualization products offered by Microsoft, see http://go.microsoft.com/fwlink/?LinkID=108563.

The following links provide more information about some of the options and technologies in Windows Server 2008 that are useful with Hyper-V:

  • Failover Clustering (http://go.microsoft.com/fwlink/?LinkID=92360)

  • Server Core Installation Option (http://go.microsoft.com/fwlink/?LinkID=82146)

  • Remote Desktop Services (http://go.microsoft.com/fwlink/?LinkID=139526)


User Interface: Hyper-V Manager

This section contains the following topics:

  • New Virtual Machine Wizard

  • New Virtual Hard Disk Wizard

  • Edit Virtual Hard Disk Wizard

  • Virtual Machine Connection

  • Virtual Machine Settings

  • Virtual Network Manager


New Virtual Machine Wizard

Page Details

Before You Begin

You can create a virtual machine without working through the pages of the wizard. If you click Finish on this page, the wizard creates a virtual machine with a default configuration. Otherwise, you can customize a virtual machine on the following pages.

For more information about the default configuration, see Create Virtual Machines.

Specify Name and Location

You can specify a name and location suited to your environment.

Important

If you plan to cluster this virtual machine hard disk, choose the option to store the virtual machine in a new folder and specify a shared location.

Assign Memory

Specify at least enough memory to run the guest operating system and all applications that you want to run simultaneously.

Configure Networking

Specify the network connection that you want to use. The Not connected option is always available. Other connections are available if virtual networks have been created. You can create one or more virtual networks when you use Server Manager to install the role, and you can create virtual networks later with the Virtual Network Manager. For more information, see Manage Virtual Networks.

Connect Virtual Hard Disk

Provides you with a way to create storage for the new virtual machine without running the New Virtual Hard Disk Wizard. This can be useful if you want to install a guest operating system in a virtual machine soon after you create it. You also can connect an existing virtual hard disk to the virtual machine.

Installation Options

If you want to install a guest operating system right after you create the virtual machine, you can specify the location of the installation media.

Completing the New Virtual Machine Wizard

Displays the configuration details you selected for the virtual machine.

Additional references

  • Virtual Machine Settings

  • New Virtual Hard Disk Wizard

  • Edit Virtual Hard Disk Wizard

  • Overview of Hyper-V


New Virtual Hard Disk Wizard

Page Details

Before You Begin

Explains the purpose of the wizard. You can create a virtual hard disk without working through the pages of the wizard. If you click Finish on this page, the wizard creates a dynamically expanding virtual hard disk with a storage capacity of 127 GB.

Choose Disk Type
  • Dynamically expanding virtual hard disks provide storage capacity as needed to store data. The size of the .vhd file is small when the disk is created and grows as data is added to the disk. The size of the .vhd file does not shrink automatically when data is deleted from the virtual hard disk. However, you can compact the disk to decrease the file size after data is deleted by using the Edit Virtual Hard Disk Wizard.

  • Fixed virtual hard disks provide storage capacity by using a .vhd file that is the size specified for the virtual hard disk when the disk is created. The size of the .vhd file remains 'fixed' regardless of the amount of data stored. However, you can use the Edit Virtual Hard Disk Wizard to increase the size of the virtual hard disk, which increases the size of the .vhd file.

  • Differencing virtual hard disks provide storage to enable you to make changes to a parent virtual hard disk without altering that disk. The size of the .vhd file for a differencing disk grows as changes are stored to the disk.

For more information about editing virtual hard disks, see Edit Virtual Hard Disk Wizard.

Specify Name and Location

Provide a name and location for the new virtual hard disk. If you plan to cluster the virtual machine that will use the virtual hard disk, specify a shared location.

Important

Do not create the virtual hard disk in a folder that is marked for encryption. Hyper-V does not support the use of storage media if Encrypting File System (EFS) has been used to encrypt the .vhd file. However, you can use files stored on a volume that uses Windows BitLocker Drive Encryption.

Configure Disk

Options for configuring the disk differ depending on the type of disk you select.

  • For fixed and dynamically expanding virtual hard disks, you can specify a size or copy the contents of an available physical disk.

  • For a differencing disk, you must specify the location of the disk you want to use as the parent virtual hard disk.

Completing the New Virtual Hard Disk Wizard

Displays the configuration details you selected for the virtual hard disk.

Additional considerations

  • The virtual hard disk is created when you click Finish to complete the wizard. Depending on the options you choose for the virtual hard disk, the process can take a considerable amount of time.

Additional references

  • New Virtual Machine Wizard

  • Overview of Hyper-V


Edit Virtual Hard Disk Wizard

You can use the Edit Virtual Hard Disk Wizard to perform various actions that modify virtual hard disks. The available actions differ depending on the type of disk you select. The following table provides information for each action.

Action Description

Compact

Applies to dynamically expanding virtual hard disks and differencing virtual hard disks. Reduces the size of the .vhd file by removing blank space that is left behind when data is deleted from the virtual hard disk. If the virtual hard disk is not NTFS formatted, the blank space must be overwritten with zeroes so that the compact action can reduce the file size by removing sectors that contain only zeroes.

Note

If the virtual hard disk is not NTFS formatted, you must prepare the virtual hard disk for compacting by using a non-Microsoft disk utility program to replace the blank space with zeroes.

Convert

Converts a dynamically expanding virtual hard disk to a fixed virtual hard disk, or vice versa.

Expand

Increases the storage capacity of a dynamically expanding virtual hard disk or a fixed virtual hard disk.

Merge

Applies to differencing disks only. Allows you to combine the changes stored in a differencing disk with the contents of the parent disk. You can either copy the contents of the parent disk and differencing disk into a new virtual hard disk, which leaves both source disks intact, or you can apply the changes to the parent disk.

Reconnect

Applies to differencing disks only. If you select a differencing disk and the parent virtual hard disk cannot be located, this page appears automatically. If the disks are part of a chain of differencing disks, this page will appear if the wizard cannot locate any of the disks in the chain.

Additional references

  • New Virtual Hard Disk Wizard

  • New Virtual Machine Wizard


Virtual Machine Connection

Virtual Machine Connection is a tool that you can use to connect to the virtual machines that run on a local or remote server. For more information, see Connect to a Virtual Machine.


Virtual Machine Settings

Virtual Machine Settings provide you with a way to adjust the configuration of a virtual machine after you create the virtual machine. For instructions, see Configuring Virtual Machines.

Some of the settings are self-explanatory and are not included in this topic. Usage considerations or additional information about settings that might not be self-explanatory are included in the following tables.

Hardware setting Description

Memory

Specify enough memory to run the guest operating system and all applications that will run at the same time on the virtual machine.

Virtual Processor

If the virtual machine runs Windows Server 2008 or Windows Server 2003 as a guest operating system, you can assign more than one virtual processor.

Resource controls

These settings provide you with a way to control how resources are allocated among virtual machines that run at the same time on one physical computer. For instructions, see Configure Memory and Processors.

Processor Compatibility

Migrate to a physical computer with a different processor version allows you to move a running virtual machine to a physical computer with different processor features without restarting the virtual machine. When this setting is enabled, the virtual machine uses only the features of the processor that are available on all versions of a virtualization-capable processor by the same processor manufacturer. When this setting is not used, Hyper-V provides the virtual machine with all the virtualization features offered by the physical processor.

COM number

A virtual COM port attached to a named pipe is most commonly used with a kernel debugger.

Note

You cannot associate the virtual COM port to a physical COM port.

Floppy Drive

A floppy drive makes it possible for a virtual machine to use a virtual floppy disk.

Note

You cannot associate the floppy drive to a physical floppy drive.

Management setting Description

Snapshot File Location

This setting allows you to override the default location by selecting a different location for the configuration and memory-storage files required for snapshots. The default location is the location specified for the server running Hyper-V. This setting does not affect the storage location of the snapshot data (.avhd) files.

Automatic Start Action

These settings let you specify whether to restart the virtual machine if the physical computer or the Hyper-V Virtual Machine Management Service restarts.

Note

If you plan to make the virtual machine highly available, do not configure the virtual machine to restart automatically. For more information, see Configure a Virtual Machine for High Availability.

Automatic Stop Action

These settings let you specify the state you want to place the virtual machine in when the physical computer shuts down.


Virtual Network Manager

Virtual Network Manager enables you to create and manage virtual networks. For instructions, see Manage Virtual Networks.

The following table describes the available settings of Virtual Network Manager.

Setting Description

External

Creates a connection to a physical network adapter so that virtual machines can access a physical network.

The Allow management operating system to share this network adapter setting controls whether you can use this physical network adapter to access to the management operating system, which is operating system that runs the Hyper-V role. You can use this option to isolate the management operating system from communications between virtual machines and other computers on a physical network. However, this also means that you cannot connect to the management operating system remotely through this physical network adapter if this option is cleared.

Internal

Provides communications between the management operating system and virtual machines.

Private

Provides communications between virtual machines only.

Enable virtual LAN identification

Specifies an identification number that can be used to isolate network traffic from the management operating system. A virtual LAN configuration must be supported by the physical network adapter. For information about configuring virtual LAN identification, see the Hyper-V deployment content at the Windows Server 2008 Technical Library (http://go.microsoft.com/fwlink/?LinkID=131362).

MAC Address Range

This setting allows you to specify a range of addresses to be used when assigning dynamic MAC addresses to virtual machines. This helps to avoid conflicts that could occur when more than one physical computer running Hyper-V uses the same subnet and the same MAC address is assigned to more than one virtual machine that communicates on that physical subnet. Dynamic MAC addresses are assigned by Hyper-V according to a default range that is the same on each installation of Hyper-V. You can use this setting to divide this default range into ‘subranges’ and assign a different subrange to each of the physical computers that runs Hyper-V.

Additional references

  • Configure Networking

  • User Interface: Hyper-V Manager